/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wawi.gui.admingui.gui;

import java.awt.Color;
import java.math.BigDecimal;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import static javax.swing.JOptionPane.showMessageDialog;
import wawi.fachlogik.adminsteuerung.grenz.ProduktGrenz;
import wawi.fachlogik.adminsteuerung.steuer.ProduktSteuerung;
import wawi.fachlogik.adminsteuerung.grenz.KategorieGrenz;
import wawi.fachlogik.adminsteuerung.steuer.KategorieSteuerung;
import wawi.gui.admingui.resources.Item;
import wawi.gui.admingui.resources.MyModelComboKategorie;
import wawi.gui.admingui.resources.MyModelComboLagerort;

/**
 *
 * @author Patrick-Sojka
 */
public class FrameProduktCreate extends javax.swing.JFrame {

    private MyModelComboKategorie mymodelcombokategorie;
    private MyModelComboLagerort mymodelcombolagerort;
    private int hiddenValueForComboKategorie;
    private int hiddenValueForComboLagerort;
    private DefaultComboBoxModel dc;
    private Item item;
    /**
     * Creates new form FrameProduktCreate
     */
    public FrameProduktCreate() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jLabel11 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        speichernProdukt = new javax.swing.JButton();
        close = new javax.swing.JButton();
        FieldName = new javax.swing.JTextField();
        FieldBeschreibung = new javax.swing.JTextField();
        FieldNettopreis = new javax.swing.JTextField();
        FieldMwst = new javax.swing.JTextField();
        FieldStueckzahl = new javax.swing.JTextField();
        BoxStatus = new javax.swing.JCheckBox();
        ComboKategorie = new javax.swing.JComboBox<>();
        ComboLagerort = new javax.swing.JComboBox<>();
        ausgabe = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jLabel11.setText("jLabel11");

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel1.setFont(new java.awt.Font("Lucida Grande", 1, 18)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Produkt anlegen");

        jLabel3.setFont(new java.awt.Font("Lucida Grande", 1, 14)); // NOI18N
        jLabel3.setText("Name*");

        jLabel4.setFont(new java.awt.Font("Lucida Grande", 1, 14)); // NOI18N
        jLabel4.setText("Beschreibung*");

        jLabel5.setFont(new java.awt.Font("Lucida Grande", 1, 14)); // NOI18N
        jLabel5.setText("Nettopreis*");

        jLabel6.setFont(new java.awt.Font("Lucida Grande", 1, 14)); // NOI18N
        jLabel6.setText("MwSt-Satz*");

        jLabel7.setFont(new java.awt.Font("Lucida Grande", 1, 14)); // NOI18N
        jLabel7.setText("Stückzahl*");

        jLabel8.setFont(new java.awt.Font("Lucida Grande", 1, 14)); // NOI18N
        jLabel8.setText("Status");

        jLabel9.setFont(new java.awt.Font("Lucida Grande", 1, 14)); // NOI18N
        jLabel9.setText("Kategorie*");

        jLabel10.setFont(new java.awt.Font("Lucida Grande", 1, 14)); // NOI18N
        jLabel10.setText("Lagerort*");

        speichernProdukt.setText("Anlegen");
        speichernProdukt.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                speichernProduktActionPerformed(evt);
            }
        });

        close.setText("Abbrechen");
        close.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeActionPerformed(evt);
            }
        });

        FieldName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FieldNameActionPerformed(evt);
            }
        });

        FieldBeschreibung.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FieldBeschreibungActionPerformed(evt);
            }
        });

        FieldNettopreis.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FieldNettopreisActionPerformed(evt);
            }
        });

        FieldMwst.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FieldMwstActionPerformed(evt);
            }
        });

        FieldStueckzahl.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                FieldStueckzahlActionPerformed(evt);
            }
        });

        BoxStatus.setText("aktiv");
        BoxStatus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                BoxStatusActionPerformed(evt);
            }
        });

        ComboKategorie.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        mymodelcombokategorie = new MyModelComboKategorie();
        ComboKategorie.setModel(mymodelcombokategorie.buildTableModel());

        //Default id
        //todo
        dc = mymodelcombokategorie.buildTableModel();
        item = (Item)dc.getElementAt(0);
        hiddenValueForComboKategorie = item.getId();
        //todo

        //Default id ENDE
        ComboKategorie.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComboKategorieActionPerformed(evt);
            }
        });
        ComboKategorie.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComboKategorieActionPerformed(evt);
                JComboBox combo = (JComboBox)evt.getSource();
                Item item = (Item) combo.getSelectedItem();
                //String currentQuantity = (String)combo.getSelectedItem();
                hiddenValueForComboKategorie = item.getId();
                ausgabe.setText("Unterkategorie:  "+hiddenValueForComboKategorie);

            }
        });

        ComboLagerort.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        mymodelcombolagerort = new MyModelComboLagerort();
        ComboLagerort.setModel(mymodelcombolagerort.buildTableModel());
        //Default id
        //todo
        dc = mymodelcombolagerort.buildTableModel();
        item = (Item)dc.getElementAt(0);
        hiddenValueForComboLagerort = item.getId();
        //todo

        //Default id ENDE
        ComboLagerort.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComboLagerortActionPerformed(evt);
            }
        });
        ComboLagerort.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComboLagerortActionPerformed(evt);
                JComboBox combo = (JComboBox)evt.getSource();
                Item item = (Item) combo.getSelectedItem();
                //String currentQuantity = (String)combo.getSelectedItem();
                hiddenValueForComboLagerort = item.getId();
                ausgabe.setText("Lagerort: String "+item.getDescription()+" Int: "+item.getId());

            }
        });

        ausgabe.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        ausgabe.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        jLabel2.setText("€");

        jLabel12.setText("%");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(ausgabe, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel3)
                                    .addComponent(jLabel4)
                                    .addComponent(jLabel5))
                                .addGap(59, 59, 59)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(FieldName)
                                    .addComponent(FieldBeschreibung))
                                .addGap(2, 2, 2))
                            .addComponent(jLabel7, javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addComponent(jLabel6)
                                .addGap(77, 77, 77)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(FieldMwst, javax.swing.GroupLayout.DEFAULT_SIZE, 468, Short.MAX_VALUE)
                                    .addComponent(FieldNettopreis, javax.swing.GroupLayout.Alignment.TRAILING))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel2)
                                    .addComponent(jLabel12, javax.swing.GroupLayout.PREFERRED_SIZE, 32, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(jLabel8)
                                    .addComponent(jLabel9)
                                    .addComponent(jLabel10))
                                .addGap(86, 86, 86)
                                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(FieldStueckzahl)
                                    .addGroup(layout.createSequentialGroup()
                                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(ComboLagerort, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(ComboKategorie, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                            .addComponent(BoxStatus))
                                        .addGap(0, 0, Short.MAX_VALUE)))))
                        .addGap(16, 16, 16))))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(close)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(speichernProdukt)
                .addGap(14, 14, 14))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {close, speichernProdukt});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(24, 24, 24)
                .addComponent(jLabel1)
                .addGap(26, 26, 26)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(FieldName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(FieldBeschreibung, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(FieldNettopreis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(FieldMwst, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel12))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(FieldStueckzahl, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(BoxStatus))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(ComboKategorie, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(23, 23, 23)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel10)
                    .addComponent(ComboLagerort, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(ausgabe, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(speichernProdukt)
                    .addComponent(close))
                .addGap(25, 25, 25))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void closeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeActionPerformed
        // TODO add your handling code here:
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        dispose();
    }//GEN-LAST:event_closeActionPerformed

    private void speichernProduktActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_speichernProduktActionPerformed
        // TODO add your handling code here:
        boolean ret;

        ProduktGrenz produktgrenz = new ProduktGrenz();

        if (FieldName.getText().equals("") || FieldBeschreibung.equals("") || FieldNettopreis.getText().equals("")|| FieldMwst.getText().equals("") || FieldStueckzahl.getText().equals("")) {
            showMessageDialog(null, "Pflichtfelder ausfüllen!");
            ausgabe.setForeground(Color.red);
            ausgabe.setText("Fehler!");
        } else {

            produktgrenz.setName(FieldName.getText());
            produktgrenz.setBeschreibung(FieldBeschreibung.getText());
            produktgrenz.setNettopreis(BigDecimal.valueOf(Double.parseDouble(FieldNettopreis.getText().replace(',', '.'))));
            produktgrenz.setMwstsatz(Integer.parseInt(FieldMwst.getText()));
            produktgrenz.setStueckzahl(Integer.parseInt(FieldStueckzahl.getText()));
            produktgrenz.setAktiv(BoxStatus.isSelected());
            produktgrenz.setKategorie(hiddenValueForComboKategorie);
            produktgrenz.setLagerort(hiddenValueForComboLagerort);
            //System.out.println("BoxStatus: "+BoxStatus.getFocusTraversalKeysEnabled());
            ProduktSteuerung produktsteuerung = new ProduktSteuerung();

            ret = produktsteuerung.produktAnlegen(produktgrenz);

            FieldName.setText("");
            FieldBeschreibung.setText("");
            FieldNettopreis.setText("");
            FieldMwst.setText("");
            FieldStueckzahl.setText("");
            BoxStatus.setText("");

            if (ret == true) {

                ausgabe.setText("Produkt wurde erfolgreich angelegt!");
            }
        }
    }//GEN-LAST:event_speichernProduktActionPerformed

    private void FieldNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FieldNameActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_FieldNameActionPerformed

    private void FieldBeschreibungActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FieldBeschreibungActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_FieldBeschreibungActionPerformed

    private void FieldNettopreisActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FieldNettopreisActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_FieldNettopreisActionPerformed

    private void FieldMwstActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FieldMwstActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_FieldMwstActionPerformed

    private void FieldStueckzahlActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_FieldStueckzahlActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_FieldStueckzahlActionPerformed

    private void BoxStatusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_BoxStatusActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_BoxStatusActionPerformed

    private void ComboKategorieActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ComboKategorieActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ComboKategorieActionPerformed

    private void ComboLagerortActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ComboLagerortActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ComboLagerortActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrameProduktCreate.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrameProduktCreate.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrameProduktCreate.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrameProduktCreate.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FrameProduktCreate().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox BoxStatus;
    private javax.swing.JComboBox<String> ComboKategorie;
    private javax.swing.JComboBox<String> ComboLagerort;
    private javax.swing.JTextField FieldBeschreibung;
    private javax.swing.JTextField FieldMwst;
    private javax.swing.JTextField FieldName;
    private javax.swing.JTextField FieldNettopreis;
    private javax.swing.JTextField FieldStueckzahl;
    private javax.swing.JLabel ausgabe;
    private javax.swing.JButton close;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JButton speichernProdukt;
    // End of variables declaration//GEN-END:variables
}
